//
//  WriteZerosToDiskObject.h
//  DriveUtilityPrivilegedHelper
//
//  Created by Kent Tu on 3/8/13.
//  Copyright (c) 2013 Torus Knot Software Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
@class WriteZerosToDiskObject;
@protocol WriteZerosToDiskObjectDelegate <NSObject>
- (void) writeZerosToDiskFinished:(WriteZerosToDiskObject*)writeZerosToDiskObject;
- (void) writeZerosToDiskFailed:(WriteZerosToDiskObject*)writeZerosToDiskObject;
- (void) writeZerosToNextBlockWillCall:(WriteZerosToDiskObject*)writeZerosToDiskObject remainToWrite:(long long int)remainToWrite;
@end
@interface WriteZerosToDiskObject : NSObject
{
    long long int totalSizeToWrite;
    long long int remainToWrite;
    long long int offsetToWrite;
    double percentageComplete;
    NSString *driveName;
    AuthorizationRef gAuth;
    id <WriteZerosToDiskObjectDelegate> delegate;
    BOOL isCancelled;
    BOOL isInProgress;
    BOOL isSuccess;
}

@property (nonatomic, assign) id <WriteZerosToDiskObjectDelegate> delegate;
@property (atomic, readonly) BOOL isInProgress;
@property (atomic, readonly) double percentageComplete;
@property (atomic, readonly) BOOL isSuccess;
- (id) initWithLocation:(long long int)offset size:(long long)size BSDName:(NSString *)bsdName;
- (void) start;
- (void) stop;
int installPrivilegedHelperTool();
+ (BOOL) writeZerosToDiskSingleBlock: (NSString *)bsdName offset:(long long int) offset size:(long long int) size;
+ (BOOL) writeZerosToDiskSingleBlock10Dot7: (NSString *)bsdName offset:(long long int) offset size:(long long int) size;
+ (BOOL) isGreaterThan10Dot7;
@end
